#include "iostream"
#include "queue"

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int r = 0, k = 0, n;
    string s;
    cin >> n >> s;
    for (auto i = 1; i < n; i++) {
        if (s[i] == '*') {
            if (r == 1) {
                r = 0;
                s[i] = '1';
            } else {
                int prev = 0, next = 0;
                char prev_char = s[i - 1], next_char = s[i + 1];
                for (auto j = i - 1; j != 0; j++) {
                    if (s[j] != prev_char)
                        break;
                    prev++;
                }
                for (auto j = i + 1; j < n; j++) {
                    if (s[j] != next_char)
                        break;
                    next++;
                }

                s[i] = prev > next ? s[i - 1] : s[i + 1];
                k++;
                r = 1;
            }
        } else if (s[i] == s[i - 1]) {
            k++;
        }
    }
    cout << k;
}
