#include <climits>
#include <cmath>
#include <iostream>
#include <map>

using namespace std;

#define rd(x) cin >> x;
#define wr(x) cout << x;
#define wrn(x) cout << x << "\n";

typedef long long ll;
typedef long double ld;

ll ans;
ll n, a, b, curminc, minc, maxc;
ll i, j, k;

map<ll, ll> mp;
map<ll, ll> r;
void solution() {
    rd(n);
    rd(a);
    rd(b);
    maxc = 0;
    for (i = 0; i < n; i++) {
        rd(k);
        j = 0;
        while (k % 2 == 0) {
            k /= 2;
            j++;
        }
        r[k] += j;
        mp[k]++;
        if (mp[k] > maxc) {
            maxc = mp[k];
        }
    }
    minc = LLONG_MAX;
    map<ll, ll>::iterator it;
    if (maxc == 1) {
        wrn(n * a - a);
    } else {
        for (it = mp.begin(); it != mp.end(); it++) {
            curminc = r[it->first] * b + (n - it->second) * a;
            if (minc > curminc) {
                minc = curminc;
            }
        }
        wrn(minc);
    }
}

int main() {
    ios::sync_with_stdio(false);
#ifdef usettt
    ll ttt;
    rd(ttt);
    while (ttt--) {
        solution();
    }
#endif
#ifndef usettt
    solution();
#endif
    return 0;
}
