#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-7;
const double pi = acos(-1);

void solve() {
	int n;
	ll x, y;
	cin >> n >> x >> y;
	ll cnt = x / y;
	
	map<ll, int> m;
	for (int i = 0; i < n; ++i) {
		ll a;
		cin >> a;
		++m[a];
	}
	
	ll ans = llinf;
	for (auto p : m) {
		ll a = p.first;
		ll res = 0;
		int left = n;
		for (ll num = a, i = 0; i <= cnt; num >>= 1, ++i) {
			if (m.count(num)) {
				res += m[num] * y * i;
				left -= m[num];
			}
			if (num & 1)
				break;
		}
		res += left * x;
		ans = min(ans, res);
	}
	
	cout << ans << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	
	return 0;
}