#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <fstream>
#include <vector>
#include <queue>
#include <stack>
#include <sstream>
#include <list>
#include <map>
#include <set>
#include <limits>
#include <random>
#include <functional>
#include <unordered_set>
#include <unordered_map>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int ui;

#define pii pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vl vector<ll>

using namespace std;

const int N = 5010;
const int M = 30;
const int MOD = 1000000007;
const int INF = 1009000999;
const ll LINF = (1ll << 60) + 1337;
const ld EPS = 0.00000001;

int gcd(int a, int b) {
    if (b == 0) return a;
    else return gcd(b, a % b);
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
    //freopen("line3.in", "r", stdin); freopen("line3.out", "w", stdout);
#endif
    ll L, R;
    cin >> L >> R;
    int q;
    cin >> q;
    while (q--) {
        ll k;
        cin >> k;
        ll l, r;
        if (L >= 0) {
            l = (L + k - 1) / k * k;
        }
        else {
            l = abs(L) / k * k * (-1LL);
        }
        if (R >= 0) {
            r = R / k * k;
        }
        else {
            r = (abs(R) + k - 1) / k * k * (-1LL);
        }
        ll n = (r - l) / k;
        if (n <= 0) cout << "0\n";
        else cout << ((n + 1LL) * n) / 2LL * k << "\n";
    }
}


/*
    Important stuff
    - int overflow
    - array bounds
    - special cases (n=1, max n) maybe adhoc problem
    - doubles are read for a long time (4 * 10 ^ 5 danger GNU vs MS ICPC 2020 1/4)
    - don't get stuck on one approach
    - don't get stuck on one problem
    - recheck submissions if near the end of the tournament and there is nothing to do
    - do something instead of nothing and stay organized
*/