#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <fstream>
#include <vector>
#include <queue>
#include <stack>
#include <sstream>
#include <list>
#include <map>
#include <set>
#include <limits>
#include <random>
#include <functional>
#include <unordered_set>
#include <unordered_map>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int ui;

#define pii pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vl vector<ll>

using namespace std;

const int N = 110;
const int M = 1010;
const int MOD = 1000000007;
const int INF = 1009000999;
const ll LINF = (1ll << 60) + 1337;
const ld EPS = 0.00000001;

int gcd(int a, int b) {
    if (b == 0) return a;
    else return gcd(b, a % b);
}

int n;
ll g[N][N];
ll c[N];
int h[N];
ll dp[M][N];

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
    //freopen("line3.in", "r", stdin); freopen("line3.out", "w", stdout);
#endif
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            g[i][j] = LINF;
        }
        g[i][i] = 0;
    }
    for (int i = 0; i < M; i++) {
        for (int j = 0; j < N; j++) {
            dp[i][j] = -LINF;
        }
    }
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> c[i] >> h[i];
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b;
        ll x;
        cin >> a >> b >> x;
        a--;
        b--;
        g[a][b] = min(g[a][b], x);
        g[b][a] = min(g[b][a], x);
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
            }
        }
    }
    ll ans = h[0] * c[0];
    dp[0][0] = 0;
    for (int t = 0; t < M; t++) {
        for (int when = 0; when < n; when++) {
            if (dp[t][when] == -LINF) continue;
            for (int to = 0; to < n; to++) {
                if (when == to) {
                    if (t + 1 >= M) continue;
                    if (t < h[when]) {
                        dp[t + 1][when] = max(dp[t + 1][when], dp[t][when] + c[when]);
                    }
                    else {
                        dp[t + 1][when] = max(dp[t + 1][when], dp[t][when]);
                    }
                }
                else {
                    if (t + g[when][to] >= M) continue;
                    dp[t + g[when][to]][to] = max(dp[t + g[when][to]][to], dp[t][when]);
                }
            }
        }
    }
    for (int i = 0; i < M; i++) {
        for (int j = 0; j < n; j++) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
}


/*
    Important stuff
    - int overflow
    - array bounds
    - special cases (n=1, max n) maybe adhoc problem
    - doubles are read for a long time (4 * 10 ^ 5 danger GNU vs MS ICPC 2020 1/4)
    - don't get stuck on one approach
    - don't get stuck on one problem
    - recheck submissions if near the end of the tournament and there is nothing to do
    - do something instead of nothing and stay organized
*/