#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>

using namespace std;


int h, w, mx[52][52], q[4][52][52], dist[4][52][52];
int dirx[4] = { 1, 1, -1, -1 }, diry[4] = { 1, -1, 1, -1 }, dirlx[4] = {1, 0, -1, 0}, dirly[4] = {0, 1, 0, -1};
string s;


int main() {
	ios_base::sync_with_stdio(0);
	cin >> w >> h;
	for (int i = 1; i <= h; i++) {
		cin >> s;
		for (int j = 1; j <= w; j++) {
			mx[i][j] = (s[j - 1] == '.');
		}
	}
	for (int i = 1; i <= h; i++) {
		for (int j = 1; j <= w; j++) {
			if (mx[i][j] == 1) {
				for (int l = 0; l < 4; l++)
					q[l][i][j] = 1;
			}
		}
	}
	for (int i = 1; i <= h; i++) {
		for (int j = 1; j <= w; j++) {
			if (mx[i][j] == 0) {
				for (int l = 0; l < 4; l++) {
					if (mx[i + diry[l]][j + dirx[l]] == 1) {
						if(mx[i][j + dirx[l]] == 1 && mx[i + diry[l]][j] == 1)
							if (l == 0) {
								q[0][i + diry[l]][j + dirx[l]] = 2;
								q[1][i + diry[l]][j + dirx[l]] = 2;
							}
							else if(l == 1) {
								q[0][i + diry[l]][j + dirx[l]] = 2;
								q[3][i + diry[l]][j + dirx[l]] = 2;
							}
							else if (l == 2) {
								q[1][i + diry[l]][j + dirx[l]] = 2;
								q[2][i + diry[l]][j + dirx[l]] = 2;
							}
							else {
								q[2][i + diry[l]][j + dirx[l]] = 2;
								q[3][i + diry[l]][j + dirx[l]] = 2;
							}
					}
				}
			}
		}
	}
	for (int l = 0; l < 4; l++) {
		for (int i = 1; i <= h; i++) {
			for (int j = 1; j <= w; j++) {
				if (mx[i][j] == 1) {
					int d = 0, i1 = i, j1 = j;
					while (mx[i1 + dirly[l]][j1 + dirlx[l]] != 0) {
						d++;
						if (q[l][i1 + dirly[l]][j1 + dirlx[l]] == 2) {
							dist[l][i][j] = d;
							break;
						}
						i1 = i1 + dirly[l];
						j1 = j1 + dirlx[l];

					}
					if (dist[l][i][j] == 0) dist[l][i][j] = -d;
				}
			}
		}
	}
	for (int i = 1; i <= h; i++) {
		for (int k = 0; k < 3; k++) {
			for (int j = 1; j <= w; j++) {
				if (k == 0) {
					if (mx[i][j] == 0) cout << "* W * ";
					else {
						cout << "* " << dist[3][i][j] << " * ";
					}
				}
				else if (k == 1) {
					if (mx[i][j] == 0) cout << "W * W ";
					else {
						cout << dist[2][i][j] << " * " << dist[0][i][j] << " ";
					}
				}
				else {
					if (mx[i][j] == 0) cout << "* W * ";
					else {
						cout << "* " << dist[1][i][j] << " * ";
					}
				}
			}
			cout << endl;
		}
	}

	return 0;
}