import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class Main7 {
    public static void main(String[] args) {
        FastReader in = new FastReader();

        int l = in.nextInt();
        int r = in.nextInt();

        int q = in.nextInt();

        while(q-- > 0) {
            int k = in.nextInt();

            int sum = 0;
            List<Integer> cnt = new ArrayList<>();
            int last = l;

            if(l % k != 0) {
                for(int i = l; i <= r; i++) {
                    if(i % k == 0) {
                        last = i;
                        break;
                    }
                }
            }


            for(int i = last; i <= r; i += k) {
                sum++;
                cnt.add(i - last);
                //System.out.println(i + " " + last);
                last = i;
            }

            long result = 0;
            for(int i = 1; i < cnt.size(); i++) {
                result += (long) cnt.get(i) * (sum - i);
            }

            /*
            boolean met = false;
            long result = 0;
            for(int i = 0; i < arr.length; i++) {
                if(met) {
                    result += sum;
                }

                if(arr[i] == 1) {
                    met = true;
                    sum--;
                }
            }*/

            System.out.println(result);
        }
    }
    static class FastReader {
        BufferedReader br;
        StringTokenizer st;

        public FastReader() {
            br = new BufferedReader(new
                    InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        String nextLine() {
            String str = "";
            try {
                str = br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }
}
