#include <bits/stdc++.h>

struct edge_t {
    int u;
    int v;
    int w;
};

int main() {
    int n;
    std::cin >> n;
    std::vector<int64_t> cost(n);
    std::vector<int> h(n);
    int max_h = 0;
    for (int i = 0; i < n; ++i) {
        std::cin >> cost[i] >> h[i];
        max_h = std::max(max_h, h[i]);
    }
    int m;
    std::cin >> m;
    std::vector< edge_t > edges(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> edges[i].u >> edges[i].v >> edges[i].w;
        --edges[i].u;
        --edges[i].v;
        edges.push_back(edges[i]);
        std::swap(edges[i].u, edges[i].v);
    }
    std::vector< std::vector<int64_t> > dp(max_h + 1, std::vector<int64_t>(n, -1));
    dp[0][0] = 0;
    int64_t ans = 0;
    for (int i = 1; i < max_h + 1; ++i) {
        // for (int j = 0; j < n; ++j) {
        //     dp[i][j] = dp[i - 1][j];
        // }
        for (size_t j = 0; j < edges.size(); ++j) {
            int u = edges[j].u;
            int v = edges[j].v;
            int w = edges[j].w;
            if (i - w >= 0 and dp[i - w][u] != -1) {
                dp[i][v] = std::max(dp[i][v], dp[i - w][u]);
            }
        }
        for (int j = 0; j < n; ++j) {
            if (i <= h[j] and dp[i - 1][j] != -1) {
                dp[i][j] = std::max(dp[i][j], dp[i - 1][j] + cost[j]);
            }
            ans = std::max(ans, dp[i][j]);
        }
    }

    // for (int i = 0; i < max_h + 1; ++i) {
    //     std::cout << i << " | ";
    //     for (int j = 0; j < n; ++j) {
    //         std::cout << dp[i][j] << ' ';
    //     }
    //     std::cout << std::endl;
    // }
    std::cout << ans << std::endl;
}
