#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
int main() {
    int n, a, b;
    cin >> n >> a >> b;
    vector<int> numbers(n);
    for (int i = 0; i < n; ++i) {
        cin >> numbers[i];
    }
    map<int, vector<int> > groups;
    vector<int> keys(n);
    for (int i = 0; i < n; ++i) {
        int check = numbers[i];
        while (check % 2 == 0) {
            check /= 2;
        }
        groups[check].push_back(numbers[i]);
        keys[i] = check;
    }
    sort(keys.begin(), keys.end());
    long long answer = -1;
    for (int i = 0; i < keys.size(); ++i) {
        if ((i == 0) || (i > 0 && keys[i] != keys[i-1])) {
            sort(groups[keys[i]].begin(), groups[keys[i]].end());
            vector<int> dist(groups[keys[i]].size());
            for (int j = 1; j < dist.size(); ++j) {
                dist[j] = dist[j-1];
                int check1 = groups[keys[i]][j];
                while (check1 != groups[keys[i]][j-1]) {
                    ++dist[j];
                    check1 /= 2;
                }
            }
            long long delet = (n - dist.size()) * a;
            int pointer = 0;
            int count = 0;
            for (int j = 0; j < dist.size(); ++j) {
                long long now = delet + (dist.size() - j - 1) * a;
                if (j > 0) {
                    count += (j - pointer) * (dist[j] - dist[j - 1]);
                    while ((dist[j] - dist[pointer]) * b > a && pointer < j) {
                        count -= (dist[j] - dist[pointer]);
                        ++pointer;
                    }
                    long long check = count * b + pointer * a;
                    now += check;
                    
                }
                if ((answer == -1) || (now < answer)) {
                    answer = now;
                }
            }
        }
    }
    cout << answer << endl;
}