#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef double ld;

const double eps = 1e-8;
const ll INFll = 1e18;
const ll INFi = 1e9 + 63;
const ll mod = 1e9 + 7;
const int maxn = 1005;
const int maxd = 6;

const double pi =acos(-1);

int caseNo = 1;

int dist[maxn][maxn][maxd];

struct coords {
    int r;
    int c;
    int prev;
};
vector<pair<int,int>> dirs{{0,0}, {-1,0}, {1,0}, {0, -1}, {0,1}};
void solve() {
    for (int i=0;i<maxn;i++) {
        for (int j=0;j<maxn;j++) {
            for (int k = 0; k < maxd; k++) {
                dist[i][j][k] = -1;
            }
        }
    }
    queue<coords> q;
    q.push({503,503, 0});
    dist[503][503][0] = 0;
    while (!q.empty()) {
        auto p = q.front();
        q.pop();
        for (int i=1;i<dirs.size();i++) {
            int nextX = p.r + dirs[i].first;
            int nextY = p.c + dirs[i].second;
            if (nextX < 0 || nextX >= maxn || nextY < 0 || nextY >= maxn) {
                continue;
            }
            if (p.prev == i) continue;
            if (dist[nextX][nextY][i] != -1) continue;
            dist[nextX][nextY][i] = dist[p.r][p.c][p.prev] + 1;
            q.push({nextX, nextY, i});
        }
    }

    int n;
    cin >> n;

    set<pair<int,int>> canVisit;
    for (int i=0;i<maxn;i++) {
        for (int j=0;j<maxn;j++) {
            for (int k = 0; k < maxd; k++) {
                if (dist[i][j][k] <= n && dist[i][j][k] != -1) {
                    canVisit.insert({i,j});
                }
            }
        }
    }
    cout << canVisit.size();
}

int main(int argc, char** argv) {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout << setprecision(15) << fixed;
   // freopen("input.txt","r",stdin);
//    precalc();
    int t = 1;
//    cin >> t;
    for (int i=0;i<t;i++)
//    while (1)
        solve();

    return 0;
}
