#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef double ld;

const double eps = 1e-8;
const ll INFll = 1e18;
const ll INFi = 1e9 + 63;
const ll mod = 1e9 + 7;
const int maxn = 105;
const int maxt = 1e3+5;

const double pi =acos(-1);

int caseNo = 1;

ll dist[maxn][maxn];
ll c[maxn], h[maxn];

ll dp[maxn][maxt];

int n;

ll getDp(int v, int t) {
    if (dp[v][t] != -1) return dp[v][t];
    dp[v][t] = 0;
    if (t<h[v]) dp[v][t] = getDp(v,t+1) + c[v];

    for (int to=0;to<n;to++) {
        ll tThere = t + dist[v][to];
        if (to==v) continue;
        if (tThere < maxt) {
            dp[v][t] = max(dp[v][t], getDp(to, tThere));
        }
    }
    return dp[v][t];
}
void solve() {

    cin >> n;
    for (int i=0;i<n;i++) {
        cin >> c[i] >> h[i];
    }
    for (int i=0;i<n;i++) {
        for (int j=0;j<n;j++) {
            dist[i][j] = INFll;
        }
        dist[i][i] = 0;
    }
    int m;
    cin >> m;
    for (int i=0;i<m;i++) {
        ll li,ri,ti;
        cin >> li >> ri >> ti;
        li--; ri--;
        dist[li][ri] = min(dist[li][ri], ti);
        dist[ri][li] = min(dist[ri][li], ti);
    }

    for (int k=0; k<n; k++)
        for (int i=0; i<n; i++)
            for (int j=0; j<n; j++)
                dist[i][j] = min (dist[i][j], dist[i][k] + dist[k][j]);

    for (int i=0;i<maxn;i++) {
        for (int j=0;j<maxt;j++) {
            dp[i][j] = -1;
        }
    }
    ll res = getDp(0,0);
    cout << res;
}

int main(int argc, char** argv) {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout << setprecision(15) << fixed;
   // freopen("input.txt","r",stdin);
//    precalc();
    int t = 1;
//    cin >> t;
    for (int i=0;i<t;i++)
//    while (1)
        solve();

    return 0;
}
