    //london calling
    
    #include <bits/stdc++.h>
    
    #define ll      long long
    #define ld      long double
    #define sz(v)   (ll)(v.size())
    #define inf     (ll)(1e17)
    #define mod     (ll)(1e9 + 7)
    #define pi      acos(-1)

    using namespace std; 

    ll dp[101][1001] = {};

    void floyd( vector< vector< ll > > &g ) {
        int n = sz(g);
        for (int k = 0; k < n; k++) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    g[i][j] = min( g[i][j], g[i][k] + g[k][j] );
                }
            }
        }
    }

    bool cmp(pair< pair<ll, ll>, ll > &p1, pair< pair<ll, ll>, ll > &p2) {
        if (p1.first.second != p2.first.second) return p1.first.second < p2.first.second;
        return p1.first.first > p2.first.first;
    }

    int main() {

        ios_base::sync_with_stdio(0);
        cin.tie(0); cout.tie(0);
        
        #ifdef LOCAL
            ifstream cin("input.txt");
            ofstream cout("output.txt"); 
        #endif

        ll n;
        cin >> n;
        
        vector< vector< ll > > g(n, vector< ll > (n, inf));
        vector< pair< pair<ll, ll>, ll > > v(n);

        for (int i = 0; i < n; i++) {
            cin >> v[i].first.first >> v[i].first.second;
            v[i].second = i;

            g[i][i] = 0;
        }

        ll m;
        cin >> m;

        for (int i = 0; i < m; i++) {
            ll u, v, t;
            cin >> u >> v >> t;
            u--; v--;

            g[u][v] = min( g[u][v], t );
            g[v][u] = min( g[v][u], t );
        }

        floyd(g);

        // for (int i = 0; i < n; i++) {
        //     for (int j = 0; j < n; j++) cout << g[i][j] << " ";
        //     cout << endl;
        // }

        ll res = 0;

        sort( v.begin() + 1, v.end(), cmp );

        // for (auto it : v) {
        //     cout << it.first.first << " " << it.first.second << " " << it.second << endl;
        // }

        for (int i = 0; i < n; i++) {
            for (int j = 1; j <= 1000; j++) {

                if (i == 0) {

                    if (j <= v[i].first.second) {
                        dp[i][j] = dp[i][j - 1] + v[i].first.first;
                    }
                    else {
                        dp[i][j] = dp[i][j - 1];
                    }

                }
                else {
                    dp[i][j] = -inf;
                    dp[i][0] = -inf;
                }

            }
        }

        for (int i = 1; i < n; i++) {
            for (int j = 1; j <= 1000; j++) {

                if (dp[i][j - 1] != -inf) {
                    if (j <= v[i].first.second) {
                        dp[i][j] = dp[i][j - 1] + v[i].first.first;
                    }
                    else {
                        dp[i][j] = dp[i][j - 1];
                    }
                }

                for (int k = 0; k < i; k++) {


                    if ( j - g[ v[i].second ][ v[k].second ] >= 0 ) {
                        dp[i][j] = max( dp[i][j], dp[k][ j - g[ v[i].second ][ v[k].second ] ] );
                    }

                }

                res = max(res, dp[i][j] );
            }
        }

        // for (int i = 0; i < n; i++) {
        //     for (int j = 0; j < 16; j++) cout << dp[i][j] << " ";
        //     cout << endl;
        // }

        cout << res;


        return 0;
    }