#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n;
    cin >> n;

    ll S = 0;
    ll K = 0;
    {
        ll bl = 0, br = 2ll * inf, bm;
        while (br - bl > 1) {
            bm = (bl + br) / 2;
            if (bm * (bm + 1) / 2 >= n)
                br = bm;
            else
                bl = bm;
        }
        K = br;
    }
    S = K * (K + 1) / 2;

    ll rem = (S - n) / 2;
    ll k = 0;

    {
        ll bl = 0, br = 2ll * inf, bm;
        while (br - bl > 1) {
            bm = (bl + br) / 2;
            if (bm * (bm + 1) / 2 >= rem)
                br = bm;
            else
                bl = bm;
        }
        k = br;
    }

    ll res = 3 * n + 2;

    for (ll delta = -1000; delta <= 1000; delta++) {
        ll kk = k + delta;
        if (kk <= 0 || kk >= K)
            continue;
        ll bl = 0, br = n + 1 - kk + 1, bm;
        while (br - bl > 1) {
            bm = (bl + br) / 2;
            if (kk * (kk - 1) / 2 + bm * (bm - 1) / 2 + n <= S)
                bl = bm;
            else
                br = bm;
        }
        ll tmp = n + 2 * (K - bl) + K - (kk - 1) + 1;
        res = min(res, tmp);
//        cout << kk << " : " << bl << ", " << tmp << "\n";
    }

    cout << res << "\n";

    return 0;
}
