#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;

    int cnt = 0;
    for (char c : s)
        cnt += c == '*';

    for (int turn = 0; cnt > 0; cnt--, turn ^= 1) {
        int pos = -1;
        for (int i = 1; i + 1 < n; i++) {
            if (s[i] == '*' && s[i - 1] != '*' && s[i + 1] != '*' && s[i - 1] == s[i + 1]) {
                if (pos == -1) pos = i;
            }
        }
        for (int i = 1; i + 1 < n; i++) {
            if (s[i] == '*' && s[i - 1] != '*' && s[i + 1] != '*') {
                if (pos == -1) pos = i;
            }
        }
        for (int i = 0; i < n; i++) {
            if (s[i] == '*' && ((i > 0 && s[i - 1] != '*') || (i + 1 < n && s[i + 1] != '*'))) {
                if (pos == -1) pos = i;
            }
        }
        for (int i = 0; i < n; i++) {
            if (s[i] == '*') {
                if (pos == -1) pos = i;
            }
        }

        if (turn == 0) { // min
            set<char> used;
            for (int d = -3; d <= 3; d++) {
                int i = pos + d;
                if (0 <= i && i < n && s[i] != '*') {
                    used.insert(s[i]);
                }
            }
            s[pos] = 'a';
            while (used.count(s[pos]))
                s[pos]++;
        } else { // max
            if (pos > 0 && s[pos - 1] != '*') s[pos] = s[pos - 1];
            else if (pos + 1 < n && s[pos + 1] != '*') s[pos] = s[pos + 1];
            else s[pos] = 'a';
        }
    }

    int k = 0;
    for (int i = 0; i + 1 < n; i++)
        k += s[i] == s[i + 1];

    cout << k << "\n";

    return 0;
}
