#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

int slow(int f, int n, vector<int> a, int m, int C, vector<vector<int>> seq, vector<int> d) {
    return 0;
}

int fast(int f, int n, vector<int> a, int m, int C, vector<vector<int>> seq, vector<int> d) {
    vector<int> dp(n, 0);
    vector<vector<int>> last(n, vector<int>(f + 1, -1));
    vector<int> used(n + 10);
    int timer = 10;
    for (int i = 0; i < n; i++) {
        if (i > 0) {
            dp[i] = dp[i - 1];
            last[i] = last[i - 1];
        }
        last[i][a[i]] = i;
        if (i + 1 >= C) {
            timer++;
            for (int j = 1; j < m; j++) {
                int x = i, ok = 1;
                for (int q = C - 1; q >= 0; q--) {
                    if (x < 0) {
                        ok = 0;
                        break;
                    }
                    int elem = seq[j][q];
                    x = last[x][elem] - 1;
                }
                if (ok && x >= -1) {
                    dp[i] = max(dp[i], (x >= 0 ? dp[x] : 0) + d[j]);
                    assert(x >= -1 && x < n);
                    used[x + 1] = timer;
                }
            }
            int j = i - C;
            while (j >= -1 && used[j + 1] == timer) j--;
            if (j >= -1)
                dp[i] = max(dp[i], (j >= 0 ? dp[j] : 0) + d[0]);
        }
    }
    return dp[n - 1];
}

void work() {
    int f;
    cin >> f;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int m, C;
    cin >> m >> C;
    vector<vector<int>> seq(m, vector<int>(C));
    vector<int> d(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < C; j++) {
            cin >> seq[i][j];
        }
        cin >> d[i];
    }
    int fs = fast(f, n, a, m, C, seq, d);
    cout << fs << "\n";
}

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    work();

    return 0;
}
