#include <bits/stdc++.h>
#define ll long long

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;

    vector <int> c(n), h(n);

    for (int i = 0; i < n; i++)
        cin >> c[i] >> h[i];

    vector <vector <int> > dist(n, vector <int> (n, 1000));

    for (int i = 0; i < n; i++)
        dist[i][i] = 0;

    int m;
    cin >> m;

    for (int i = 0; i < m; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        u--;
        v--;
        dist[u][v] = min(dist[u][v], t);
        dist[v][u] = min(dist[v][u], t);
    }

    for (int k = 0; k < n; k++)
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);

    vector <vector <int> > dp(1001, vector <int> (n));

    for (int i = 999; i >= 0; i--)
        for (int j = 0; j < n; j++)
        {
            if (h[j] > i)
                dp[i][j] = c[j] + dp[i + 1][j];

            for (int k = 0; k < n; k++)
                if (i + dist[j][k] <= 1000)
                    dp[i][j] = max(dp[i][j], dp[i + dist[j][k]][k]);
        }

    cout << dp[0][0];
}
