#include <cmath>
#include <iostream>
#include <map>

using namespace std;

#define rd(x) cin >> x;
#define wr(x) cout << x;
#define wrn(x) cout << x << "\n";

#define chk(x, y) ((p[x][y] == '.') || (p[x][y] == '*'))

typedef long long ll;
typedef long double ld;

ll ans;
ll w, h, n, a, b;
ll i, j, k;
char p[51][51];
int u[51][51];
int r[51][51];
int d[51][51];
int l[51][51];
ll c;

void solution() {
    rd(w);
    rd(h);
    for (i = 0; i < h; i++) {
        for (j = 0; j < w; j++) {
            rd(p[j][i]);
        }
    }
    for (i = 0; i < h - 1; i++) {
        for (j = 0; j < w - 1; j++) {
            if (p[j][i] != '#') {
                continue;
            }
            if (chk(j + 1, i + 1) && chk(j, i + 1) && chk(j + 1, i)) {
                p[j + 1][i + 1] = '*';
            }
        }
    }
    for (i = 1; i < h; i++) {
        for (j = 0; j < w - 1; j++) {
            if (p[j][i] != '#') {
                continue;
            }
            if (chk(j + 1, i - 1) && chk(j, i - 1) && chk(j + 1, i)) {
                p[j + 1][i - 1] = '*';
            }
        }
    }
    for (i = 1; i < h; i++) {
        for (j = 1; j < w; j++) {
            if (p[j][i] != '#') {
                continue;
            }
            if (chk(j - 1, i - 1) && chk(j, i - 1) && chk(j - 1, i)) {
                p[j - 1][i - 1] = '*';
            }
        }
    }
    for (i = 0; i < h - 1; i++) {
        for (j = 1; j < w; j++) {
            if (p[j][i] != '#') {
                continue;
            }
            if (chk(j - 1, i + 1) && chk(j, i + 1) && chk(j - 1, i)) {
                p[j - 1][i + 1] = '*';
            }
        }
    }
    /*
    for (i = 0; i < h; i++) {
        for (j = 0; j < w; j++) {
            wr(p[j][i]);
        }
        wr("\n");
    }
    */
    for (i = 0; i < h; i++) {
        for (j = 0; j < w; j++) {
            if (p[j][i] == '#') {
                continue;
            }
            u[j][i] = 1;
            while ((i - u[j][i] >= 0) && (p[j][i - u[j][i]] == '.')) {
                u[j][i]++;
            }
            if ((i - u[j][i] < 0) || (p[j][i - u[j][i]] == '#')) {
                u[j][i]--;
                u[j][i] *= -1;
            }
            d[j][i] = 1;
            while ((i + d[j][i] < h) && (p[j][i + d[j][i]] == '.')) {
                d[j][i]++;
            }
            if ((i + d[j][i] >= h) || (p[j][i + d[j][i]] == '#')) {
                d[j][i]--;
                d[j][i] *= -1;
            }
            l[j][i] = 1;
            while ((j - l[j][i] >= 0) && (p[j - l[j][i]][i] == '.')) {
                l[j][i]++;
            }
            if ((j - l[j][i] < 0) || (p[j - l[j][i]][i] == '#')) {
                l[j][i]--;
                l[j][i] *= -1;
            }
            r[j][i] = 1;
            while ((j + r[j][i] < w) && (p[j + r[j][i]][i] == '.')) {
                r[j][i]++;
            }
            if ((j + r[j][i] >= w) || (p[j + r[j][i]][i] == '#')) {
                r[j][i]--;
                r[j][i] *= -1;
            }
        }
    }
    for (i = 0; i < h; i++) {
        for (j = 0; j < w; j++) {
            if (p[j][i] == '#') {
                wr("* W * ");
            } else {
                wr("* ");
                wr(u[j][i]);
                wr(" * ");
            }
        }
        wr("\n");
        for (j = 0; j < w; j++) {
            if (p[j][i] == '#') {
                wr("W * W ");
            } else {
                wr(l[j][i]);
                wr(" * ");
                wr(r[j][i]);
                wr(" ");
            }
        }
        wr("\n");
        for (j = 0; j < w; j++) {
            if (p[j][i] == '#') {
                wr("* W * ");
            } else {
                wr("* ");
                wr(d[j][i]);
                wr(" * ");
            }
        }
        wr("\n");
    }
}

int main() {
    ios::sync_with_stdio(false);
#ifdef usettt
    ll ttt;
    rd(ttt);
    while (ttt--) {
        solution();
    }
#endif
#ifndef usettt
    solution();
#endif
    return 0;
}
