#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-7;
const double pi = acos(-1);

ll f(ll x) {
	ll res;
	if ((8 * llinf) / ((8 + 4 * (x - 1)) / 2) >= x)
		res = 1 + (8 + 4 * (x - 1)) / 2 * x;
	else
		res = 8 * llinf;
	return res;
}

void solve() {
	ll n;
	cin >> n;
	
	if (n <= 5) {
		ll preans[6] = {0, 5, 8, 10, 12, 13};
		cout << preans[n] << endl;
		return;
	}
	
	ll l = 0, r = llinf;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if (f(m) < n)
			l = m;
		else
			r = m;
	}
	
	ll len = r;
	ll a = f(r - 1) + 1;
	ll b = f(r);
	
	ll ans = b + (n - (a - 1));
	ans += (n >= a);
	ans += (n >= a + len - 1);
	ans += (n >= a + len + len - 1);
	ans += (n >= a + len + len + len - 1);
	
	cout << ans << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	
	return 0;
}