#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-7;
const double pi = acos(-1);

void solve() {
	ll l, r;
	int q;
	cin >> l >> r >> q;
	
	for (int i = 0; i < q; ++i) {
		ll k;
		cin >> k;
		
		ll cnt1, cnt2, cnt;
		if (l > 0 && r > 0) {
			cnt1 = abs(r) / k + 1;
			cnt2 = abs(l - 1) / k + 1;
			cnt = abs(cnt1 - cnt2);
		}
		else if (l < 0 && r < 0) {
			cnt1 = abs(r + 1) / k + 1;
			cnt2 = abs(l) / k + 1;
			cnt = abs(cnt1 - cnt2);
		}
		else {
			cnt1 = abs(l) / k;
			cnt2 = abs(r) / k;
			cnt = cnt1 + cnt2 + 1;
		}
		
		cout << cnt * (cnt - 1) / 2 * k << endl;
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	
	return 0;
}