#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-7;
const double pi = acos(-1);

char mex(char a, char b) {
	for (char c = 'a';; ++c)
		if (c != a && c != b)
			return c;
}

void solve() {
	int n;
	string s;
	cin >> n >> s;
	s = "#" + s + "#";
	
	for (char t = 0;; t ^= 1) {
		bool gameover = true;
		for (char c : s)
			gameover &= (c != '*');
		if (gameover)
			break;
		
		if (t == 0) {
			int pos = 0;
			for (int i = 2; i <= n - 1; ++i)
				if (s[i] == '*' && s[i - 1] == s[i + 1]) {
					pos = i;
					break;
				}
			if (pos) {
				s[pos] = mex(s[pos - 1], s[pos + 1]);
				continue;
			}
			
			for (int i = 2; i <= n - 2; ++i)
				if ('a' <= s[i - 1] && s[i - 1] <= 'z' && s[i] == '*' && s[i + 1] == '*' && 'a' <= s[i + 2] && s[i + 2] <= 'z' && s[i - 1] == s[i + 2]) {
					pos = i;
					break;
				}
			if (pos) {
				s[pos] = mex(s[pos - 1], s[pos + 2]);
				continue;
			}
			
			for (int i = 1; i <= n; ++i)
				if (s[i] == '*' && 'a' <= s[i - 1] && s[i - 1] <= 'z') {
					char c = s[i + 1];
					for (int j = i + 1; j <= n; ++j) {
						c = s[j];
						if ('a' <= s[j] && s[j] <= 'z')
							break;
					}
					s[i] = mex(s[i - 1], c);
					break;
				}
				else if (s[i] == '*' && 'a' <= s[i + 1] && s[i + 1] <= 'z') {
					char c = s[i - 1];
					for (int j = i - 1; j >= 1; --j) {
						c = s[j];
						if ('a' <= s[j] && s[j] <= 'z')
							break;
					}
					s[i] = mex(s[i + 1], c);
					break;
				}
		}
		else {
			int pos = 0;
			for (int i = 2; i <= n - 1; ++i)
				if (s[i] == '*' && s[i - 1] == s[i + 1]) {
					pos = i;
					break;
				}
			if (pos) {
				s[pos] = s[pos - 1];
				continue;
			}
			
			for (int i = 2; i <= n - 2; ++i)
				if ('a' <= s[i - 1] && s[i - 1] <= 'z' && s[i] == '*' && s[i + 1] == '*' && 'a' <= s[i + 2] && s[i + 2] <= 'z' && s[i - 1] == s[i + 2]) {
					pos = i;
					break;
				}
			if (pos) {
				s[pos] = s[pos - 1];
				continue;
			}
			
			for (int i = 1; i <= n; ++i)
				if (s[i] == '*' && 'a' <= s[i - 1] && s[i - 1] <= 'z') {
					s[i] = s[i - 1];
					break;
				}
				else if (s[i] == '*' && 'a' <= s[i + 1] && s[i + 1] <= 'z') {
					s[i] = s[i + 1];
					break;
				}
		}
	}
	
	int ans = 0;
	for (int i = 1; i <= n - 1; ++i)
		ans += (s[i] == s[i + 1]);
	
	cout << ans << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	
	return 0;
}