#include <bits/stdc++.h>

using namespace std;

#define flush cout.flush

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pl = pair<ll, ll>;
const ll INF = 1e9 + 7;
const ll mod = 1e9 + 7;
const ll mod2 = 998244353;
const ld eps = 1e-9;
const ld PI = acos(-1);

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    ll n, a, b;
    cin >> n >> a >> b;
    map<ll, vector<ll>> m;
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        ll cnt = 0;
        while (x % 2 == 0) {
            cnt++;
            x /= 2;
        }
        m[x].push_back(cnt);
    }
    for (auto &p : m) {
        sort(p.second.begin(), p.second.end());
    }
    map<ll, vector<ll>> pref;
    for (auto &[x, p] : m) {
        pref[x].resize(p.size() + 1);
        pref[x][0] = 0;
        for (ll i = 1; i <= p.size(); ++i) {
            pref[x][i] = pref[x][i - 1] + p[i - 1];
        }
    }
    ll res = INF * INF;
    for (auto &[x, p] : m) {
        for (ll i = 0; i < p.size(); ++i) {
            ll l = -1, r = i;
            ll N = p[i];
            while (r - l > 1) {
                ll mid = (r + l) >> 1;
                if ((N - p[mid]) * b > a) {
                    l = mid;
                } else r = mid;
            }
            ll cur = r * a;
            cur += (p.size() - i - 1) * a;
            ll nn = n - p.size();
            cur += nn * a;
            cur += ((i - r + 1) * p[i] - (pref[x][i + 1] - pref[x][r])) * b;
            res = min(res, cur);
        }
    }
    cout << res << "\n";
    return 0;
}