#include <bits/stdc++.h>
#define ll long long
#define ff first
#define ss second
using namespace std;

vector <int> dr = {-1, -1, 1, 1},
             dc = {-1, 1, 1, -1};

int R, C;

vector <vector<char>> A;
vector <vector<bool>> _A;

vector <vector<vector<int>>> Ans;

int dir(int r, int c, int _r, int _c)
{
    if (r == _r)
    {
        if (_c - c > 0)
        {
            return 1;
        }
        else
        {
            return 3;
        }
    }
    else
    {
        if (_r - r > 0)
        {
            return 2;
        }
        else
        {
            return 0;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    //int tt; cin >> tt; while(tt--) {solve(); cout << "\n";

    cin >> C >> R;

    A = vector <vector<char>> (R + 2, vector<char> (C + 2, '#'));
    _A = vector <vector<bool>> (R + 2, vector<bool> (C + 2));
    Ans = vector <vector<vector<int>>> (R + 2, vector<vector<int>> (C + 2, vector<int> (4, INT_MAX)));

    for (int i = 1; i <= R; ++i)
    {
        for (int j = 1; j <= C; ++j)
        {
            cin >> A[i][j];
        }
    }

    for (int i = 1; i <= R; ++i)
    {
        for (int j = 1; j <= C; ++j)
        {
            if (A[i][j] == '#')
            {
                for (int k = 0; k < 4; ++k)
                {
                    if (A[i + dr[k]][j + dc[k]] == '.'
                     && A[i][j + dc[k]] == '.'
                     && A[i + dr[k]][j] == '.')
                    {
                        _A[i + dr[k]][j + dc[k]] = 1;
                        Ans[i][j + dc[k]][dir(i, j + dc[k], i + dr[k], j + dc[k])] = 1;
                        Ans[i + dr[k]][j][dir(i + dr[k], j, i + dr[k], j + dc[k])] = 1;
                    }
                }
            }
        }
    }

    int dr;

    dr = 0;
    for (int i = 1; i <= R; ++i)
    {
        for (int j = 1; j <= C; ++j)
        {
            if (A[i][j] == '.')
            {
                if (Ans[i][j][dr] != INT_MAX)
                {
                    continue;
                }
                if (A[i - 1][j] == '#')
                {
                    Ans[i][j][dr] = 0;
                }
//                else if (_A[i - 1][j])
//                {
//                    Ans[i][j][dr] = 1;
//                }
                else
                {
                    if (Ans[i - 1][j][dr] > 0)
                    {
                        Ans[i][j][dr] = Ans[i - 1][j][dr] + 1;
                    }
                    else
                    {
                        Ans[i][j][dr] = Ans[i - 1][j][dr] - 1;
                    }
                }
            }
        }
    }

    dr = 1;
    for (int j = C; j >= 1; --j)
    {
        for (int i = 1; i <= R; ++i)
        {
            if (A[i][j] == '.')
            {
                if (Ans[i][j][dr] != INT_MAX)
                {
                    continue;
                }
                if (A[i][j + 1] == '#')
                {
                    Ans[i][j][dr] = 0;
                }
//                else if (_A[i][j + 1])
//                {
//                    Ans[i][j][dr] = 1;
//                }
                else
                {
                    if (Ans[i][j + 1][dr] > 0)
                    {
                        Ans[i][j][dr] = Ans[i][j + 1][dr] + 1;
                    }
                    else
                    {
                        Ans[i][j][dr] = Ans[i][j + 1][dr] - 1;
                    }
                }
            }
        }
    }

    dr = 2;
    for (int i = R; i >= 1; --i)
    {
        for (int j = 1; j <= C; ++j)
        {
            if (A[i][j] == '.')
            {
                if (Ans[i][j][dr] != INT_MAX)
                {
                    continue;
                }
                if (A[i + 1][j] == '#')
                {
                    Ans[i][j][dr] = 0;
                }
//                else if (_A[i + 1][j])
//                {
//                    Ans[i][j][dr] = 1;
//                }
                else
                {
                    if (Ans[i + 1][j][dr] > 0)
                    {
                        Ans[i][j][dr] = Ans[i + 1][j][dr] + 1;
                    }
                    else
                    {
                        Ans[i][j][dr] = Ans[i + 1][j][dr] - 1;
                    }
                }
            }
        }
    }

    dr = 3;
    for (int j = 1; j <= C; ++j)
    {
        for (int i = 1; i <= R; ++i)
        {
            if (A[i][j] == '.')
            {
                if (Ans[i][j][dr] != INT_MAX)
                {
                    continue;
                }
                if (A[i][j - 1] == '#')
                {
                    Ans[i][j][dr] = 0;
                }
//                else if (_A[i][j - 1])
//                {
//                    Ans[i][j][dr] = 1;
//                }
                else
                {
                    if (Ans[i][j - 1][dr] > 0)
                    {
                        Ans[i][j][dr] = Ans[i][j - 1][dr] + 1;
                    }
                    else
                    {
                        Ans[i][j][dr] = Ans[i][j - 1][dr] - 1;
                    }
                }
            }
        }
    }

    vector <vector<int>> ans(3 * R + 2, vector<int> (3 * C + 2, INT_MAX - 1));

    for (int i = 1; i <= R; ++i)
    {
        for (int j = 1; j <= C; ++j)
        {
            int r = (i - 1) * 3 + 1, c = (j - 1) * 3 + 1;
            if (A[i][j] == '#')
            {
                ans[r + 0][c + 1] = INT_MAX;
                ans[r + 1][c + 2] = INT_MAX;
                ans[r + 2][c + 1] = INT_MAX;
                ans[r + 1][c + 0] = INT_MAX;
            }
            else
            {
                ans[r + 0][c + 1] = Ans[i][j][0];
                ans[r + 1][c + 2] = Ans[i][j][1];
                ans[r + 2][c + 1] = Ans[i][j][2];
                ans[r + 1][c + 0] = Ans[i][j][3];
            }
        }
    }

    for (int i = 1; i <= 3 * R; ++i)
    {
        for (int j = 1; j <= 3 * C; ++j)
        {
            if (ans[i][j] == INT_MAX)
            {
                cout << "W ";
            }
            else if (ans[i][j] == INT_MAX - 1)
            {
                cout << "* ";
            }
            else
            {
                cout << ans[i][j] << " ";
            }
        }
        cout << "\n";
    }

}

/*

*/














