#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <fstream>
#include <vector>
#include <queue>
#include <stack>
#include <sstream>
#include <list>
#include <map>
#include <set>
#include <limits>
#include <random>
#include <functional>
#include <unordered_set>
#include <unordered_map>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int ui;

#define pii pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vl vector<ll>

using namespace std;

const int N = 70;
const int M = 1010;
const int MOD = 1000000007;
const int INF = 1009000999;
const ll LINF = (1ll << 60) + 1337;
const ld EPS = 0.00000001;

int gcd(int a, int b) {
    if (b == 0) return a;
    else return gcd(b, a % b);
}

int n, m;
char pole[N][N];
int gachi[N][N][4];
int ans[N][N][4];
int dx[] = { 3,3,0,0 };
int dy[] = { 2,1,2,1 };
int diorx[] = { -1,0,0,1 };
int diory[] = { 0,-1,1,0 };

void printGachi() {
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << "* " << gachi[i][j][0] << " * ";
        }
        cout << "\n";
        for (int j = 1; j <= m; j++) {
            cout << gachi[i][j][1] << " * " << gachi[i][j][2] << " ";
        }
        cout << "\n";
        for (int j = 1; j <= m; j++) {
            cout << "* " << gachi[i][j][3] << " * ";
        }
        cout << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
    //freopen("line3.in", "r", stdin); freopen("line3.out", "w", stdout);
#endif
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            pole[i][j] = '$';
        }
    }
    cin >> m >> n;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> pole[i][j];
        }
    }
    for (int t = 0; t < 4; t++) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                if (pole[i][j] != '.') continue;
                int xw = i - diorx[dx[t]];
                int yw = j - diory[dy[t]];
                int x1 = i - diorx[dx[t]];
                int y1 = j;
                int x2 = i;
                int y2 = j - diory[dy[t]];
                if (pole[xw][yw] != '.' && pole[x1][y1] == '.' && pole[x2][y2] == '.') {
                    gachi[i][j][dx[t]] = 1;
                    gachi[i][j][dy[t]] = 1;
                }
            }
        }
    }
    //printGachi();
    //cout << "\n";
    for (int t = 0; t < 4; t++) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                if (pole[i][j] != '.') continue;
                int d = 0;
                int x = i + diorx[t];
                int y = j + diory[t];
                while (pole[x][y] == '.' && !gachi[x][y][t]) {
                    x += diorx[t];
                    y += diory[t];
                    d++;
                }
                if (gachi[x][y][t]) d++;
                else d *= -1;
                ans[i][j][t] = d;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (pole[i][j] != '.') cout << "* W * ";
            else cout << "* " << ans[i][j][0] << " * ";
        }
        cout << "\n";
        for (int j = 1; j <= m; j++) {
            if (pole[i][j] != '.') cout << "W * W ";
            else cout << ans[i][j][1] << " * " << ans[i][j][2] << " ";
        }
        cout << "\n";
        for (int j = 1; j <= m; j++) {
            if (pole[i][j] != '.') cout << "* W * ";
            else cout << "* " << ans[i][j][3] << " * ";
        }
        cout << "\n";
    }
}


/*
    Important stuff
    - int overflow
    - array bounds
    - special cases (n=1, max n) maybe adhoc problem
    - doubles are read for a long time (4 * 10 ^ 5 danger GNU vs MS ICPC 2020 1/4)
    - don't get stuck on one approach
    - don't get stuck on one problem
    - recheck submissions if near the end of the tournament and there is nothing to do
    - do something instead of nothing and stay organized
*/