#include <bits/stdc++.h>

const std::vector<int> dx = {0, 0, -1, 1};
const std::vector<int> dy = {-1, 1, 0, 0};


using pair_t = std::pair<int, int>;
using set_cord_t = std::set< pair_t >;

void dfs(pair_t u, int n, int last_move, set_cord_t & visited) {
    if (n < 0) {
        return;
    }
    if (visited.find(u) != visited.end()) {
        return;
    }
    visited.insert(u);
    // std::cout << u.first << ' ' << u.second << std::endl;
    for (int i = 0; i < 4; ++i) {
        if (i != last_move) {
            pair_t v = u;
            v.first = v.first + dx[i];
            v.second = v.second + dy[i];
            dfs(v, n - 1, i, visited);
        }
    }
}

int main() {
    int n;
    std::cin >> n;
    set_cord_t visited;
    dfs(pair_t(0, 0), n, -1, visited);
    std::cout << visited.size() << std::endl;
}
