#include <bits/stdc++.h>
#define ll long long
#define ff first
#define ss second

using namespace std;

ll n, m, l, r, t;
ll h[101];
ll c[101];
ll d[101][101];

struct town{
    ll coins;
    ll way;
};

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    vector< ll > times = {0};
    for(int i = 1; i <= n; ++i){
        cin >> c[i] >> h[i];
        times.push_back(h[i]);
    }
    sort(times.begin(), times.end());
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= n; ++j){
            if(i != j)
                d[i][j] = 1e10;
            else
                d[i][j] = 0;
        }
    }
    cin >> m;
    for(int i = 0; i < m; ++i){
        cin >> l >> r >> t;
        d[l][r] = t;
        d[r][l] = t;
    }
	for (int k=1; k<=n; ++k)
        for (int i=1; i<=n; ++i)
            for (int j=1; j<=n; ++j)
                d[i][j] = min (d[i][j], d[i][k] + d[k][j]);
    vector<town> city(n + 1);
    vector<town> new_city(n + 1);
    for(int i = 1; i <= n; ++i){
        city[i].coins = 0;
        city[i].way = d[1][i];
    }
    for(int T = 1; T <= n; ++T){
        new_city =  city;
        ll t_now = times[T];
        ll t_prev = times[T - 1];
        ll dt = t_now - t_prev;
        for(int i = 1; i <= n; ++i){
            for(int j = 1; j <= n; ++j){
                if(city[j].way == 0 && (new_city[i].coins + (d[i][j] - new_city[i].way) * c[i] <= city[j].coins)){
                    new_city[i].coins = city[j].coins;
                    new_city[i].way = d[i][j] - dt;
                    if(new_city[i].way < 0 && t_now <= h[i]){
                        new_city[i].coins += abs(new_city[i].way) * c[i];
                        new_city[i].way = 0;
                    }
                }
            }
        }
        city = new_city;
//        cout << "step" << T << "\n";
//        cout << "time:" << t_now << "\n";
//        for(int i = 1; i <= n; ++i){
//            cout << "city" << i << "    " << city[i].coins << " " << city[i].way << "\n";
//        }
    }
    ll ans = 0;
    for(int i = 1; i <= n; ++i){
        ans = max(ans, city[i].coins);
    }
    cout << ans;
}
