#include <bits/stdc++.h>

using namespace std;

int main() {
    size_t n;
    long long A, B;
    cin >> n >> A >> B;
    vector<int> data(n);
    for (size_t i = 0; i < n; ++i) {
        cin >> data[i];
    }
    vector<pair<int, int>> pows(n);
    map<int, vector<int>> bases;
    for (size_t i = 0; i < n; ++i) {
        int pow = 0;
        int num = data[i];
        while (num % 2 == 0) {
            num /= 2;
            pow++;
        }
        pows[i] = {pow, num};
        bases[num].push_back(pow);
    }
    long long ans = n * A;
    for (auto& [base, pows]: bases) {
        int mx = *max_element(pows.begin(), pows.end());
        long long del = A * (n - pows.size());
        long long add = 0;
        for (auto pw : pows) {
            add += (mx - pw) * B;
        }
        ans = min(ans, del + add);
    }
    std::cout << ans << '\n';
}
