#include <bits/stdc++.h>

using namespace std;

int main() {
    long long n;
    long long A, B;
    cin >> n >> A >> B;
    vector<int> data(n);
    for (size_t i = 0; i < n; ++i) {
        cin >> data[i];
    }
    vector<pair<int, int>> pows(n);
    map<int, vector<int>> bases;
    for (size_t i = 0; i < n; ++i) {
        int pow = 0;
        int num = data[i];
        while (num % 2 == 0) {
            num /= 2;
            pow++;
        }
        pows[i] = {pow, num};
        bases[num].push_back(pow);
    }
    long long ans = (n - 1) * A;
    for (auto& [base, pows]: bases) {
        sort(pows.begin(), pows.end());
        long long del = A * (n - pows.size());
        long long acc = 0;
        int mx = pows.back();
        for (int i = (int)pows.size() - 1; i >= 0; --i) {
            ans = min(ans, del + (i + 1) * A + acc);
            acc += (mx - pows[i]) * B;
        }
        acc = 0;
        mx = pows[0];
        for (long long i = 1; i < pows.size(); ++i) {
            ans = min(ans, del + (long long)(pows.size() - i - 1) * A + (pows[i] - mx) * i + acc);
            acc += (pows[i] - mx) * i;
            mx = pows[i];
        }
    }
    std::cout << ans << '\n';
}
