    #include <bits/stdc++.h>

    using namespace std;

    int main() {
        long long n;
        long long A, B;
        cin >> n >> A >> B;
        vector<int> data(n);
        for (size_t i = 0; i < n; ++i) {
            cin >> data[i];
        }
        vector<pair<int, int>> pows(n);
        map<int, vector<int>> bases;
        for (size_t i = 0; i < n; ++i) {
            int pow = 0;
            int num = data[i];
            while (num % 2 == 0) {
                num /= 2;
                pow++;
            }
            pows[i] = {pow, num};
            bases[num].push_back(pow);
        }
        long long ans = (n - 1) * A;
        for (auto& [base, pows]: bases) {
            sort(pows.begin(), pows.end());
            long long sz = pows.size();
            long long del = (n - sz) * A;
            long long mx_l = 0;
            long long mx_r = pows.back();
            long long sum_l = 0;
            long long sum = 0;
            for (int i : pows) {
                sum += i;
            }
            for (long long i = 0; i <= pows.size(); ++i) {
                long long cost_l = del + (mx_l * i - sum_l) * B + (sz - i) * A; // del right
                long long cost_r = del + (mx_r * (sz - i) - sum + sum_l) * B + i * A;
                ans = min(ans, cost_l);
                ans = min(ans, cost_r);
                if (i < pows.size()) {
                    mx_l = pows[i];
                    sum_l += pows[i];
                }
            }
        }
        std::cout << ans << '\n';
    }
