#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll calc(ll A, ll B, vector<ll>& pows, ll sum, ll l, ll r) {
    return l * A + ((r - l) * pows[r - 1] - sum) * B + (long long)(pows.size() - r) * A;
}

int main() {
    long long n;
    long long A, B;
    cin >> n >> A >> B;
    vector<int> data(n);
    for (size_t i = 0; i < n; ++i) {
        cin >> data[i];
    }
    map<int, vector<ll>> bases;
    for (size_t i = 0; i < n; ++i) {
        int pow = 0;
        int num = data[i];
        while (num % 2 == 0) {
            num /= 2;
            pow++;
        }
        bases[num].push_back(pow);
    }
    long long ans = (n - 1) * A;
    for (auto& [base, pows]: bases) {
        sort(pows.begin(), pows.end());
        long long sz = pows.size();
        if (pows.front() == pows.back()) {
            ans = min(ans, (n - sz) * A);
        }
        ll l = 0;
        ll sum = pows[0];
        for (ll r = 1; r <= sz; ++r) {
            while (calc(A, B, pows, sum, l, r) >= calc(A, B, pows, sum - pows[l], l + 1, r)) {
                ans = min(ans, calc(A, B, pows, sum - pows[l], l + 1, r) + (n - sz) * A);
                sum -= pows[l];
                l++;
            }
            ans = min(ans, calc(A, B, pows, sum, l, r) + (n - sz) * A);
            if (r < sz) {
                sum += pows[r];
            }
        }
    }
    std::cout << ans << '\n';
}
