#include <bits/stdc++.h>

using namespace std;

int dx[4] = {-1, 1, 0, 0};
int dy[4] = {0, 0, 1, -1};
map<pair<size_t, size_t>, bool> used;
set<pair<int, int>> pts_d;
set<pair<int, int>> pts_n;
size_t cnt = 0;

void dfs(pair<int, int> v, size_t depth, size_t n, int dir) {
    if (depth > n) {
        return;
    }
    if (!used[v]) {
        pts_d.insert(v);
        ++cnt;
    }
    used[v] = true;
    auto [x, y] = v;
    for (int i = 0; i < 4; ++i) {
        if (dir == i) {
            continue;
        }
        int n_x = x + dx[i];
        int n_y = y + dy[i];
        dfs({n_x, n_y}, depth + 1, n, i);
    }
}

int main() {
    int n;
    cin >> n;
    size_t ans = 0;
//    dfs({0, 0}, 0, n, -1);
    for (int i = -n; i <= n; ++i) {
        for (int j = -n; j <= n; ++j) {
            if (abs(i) + abs(j) > n) {
                continue;
            }
            int mi = min(abs(i), abs(j));
            int ma = max(abs(i), abs(j));
            int to_go = ma - mi;
            size_t dist = 2 * mi + to_go / 2 * 4 + to_go % 2;
            if (dist <= n) {
                pts_n.insert({i, j});
                ++ans;
            }
        }
    }
//    for (auto v: pts_n) {
//        if (pts_d.find(v) == pts_d.end()) {
//            std::cout << v.first << " " << v.second << "\n";
//        }
//    }
//    std::cout << "======\n";
//
//    for (auto v: pts_d) {
//        if (pts_n.find(v) == pts_n.end()) {
//            std::cout << v.first << " " << v.second << "\n";
//        }
//    }
//    cout << cnt << '\n';
    cout << ans;
}
