#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

int get_cnt(int x, int base) {
    if (x == 0) return 1;
    int cnt = 0;
    while (x > 0)
        x /= base, cnt++;
    return cnt;
}

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, a, b;
    cin >> n >> a >> b;

    vector<int> xs(n);
    for (int i = 0; i < n; i++)
        cin >> xs[i];

    unordered_map<ll, int> cnt;
    for (int i = 0; i < n; i++)
        cnt[xs[i]]++;

    ll res = 1ll * n * a;
    for (int i = 0; i < n; i++) {
        ll tmp = 0, cur = 0, rem = n;
        for (int val = xs[i];; cur += b) {
            tmp += min(cur, ll(a)) * cnt[val];
            rem -= cnt[val];
            res = min(res, tmp + rem * a);
            if (val % 2)
                break;
            else
                val /= 2;
        }
    }

    cout << res << "\n";

    return 0;
}
