#include <bits/stdc++.h>
#define ll long long

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> m >> n;
    char field[50][50];

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> field[i][j];

    vector <vector <vector <int> > > key_dir(n);

    for (int i = 0; i < n; i++)
    {
        key_dir[i].resize(m);

        for (int j = 0; j < m; j++)
            key_dir[i][j].resize(4);
    }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (field[i][j] == '#')
            {
                if (i > 0 && j > 0 && field[i - 1][j - 1] == '.' && field[i - 1][j] == '.' && field[i][j - 1] == '.')
                    key_dir[i - 1][j - 1][1] = key_dir[i - 1][j - 1][2] = 1;

                if (i > 0 && j < m - 1 && field[i - 1][j + 1] == '.' && field[i - 1][j] == '.' && field[i][j + 1] == '.')
                    key_dir[i - 1][j + 1][2] = key_dir[i - 1][j + 1][3] = 1;

                if (i < n - 1 && j > 0 && field[i + 1][j - 1] == '.' && field[i + 1][j] == '.' && field[i][j - 1] == '.')
                    key_dir[i + 1][j - 1][0] = key_dir[i + 1][j - 1][1] = 1;

                if (i < n - 1 && j < m - 1 && field[i + 1][j + 1] == '.' && field[i][j + 1] == '.' && field[i + 1][j] == '.')
                    key_dir[i + 1][j + 1][0] = key_dir[i + 1][j + 1][3] = 1;
            }

    vector <vector <int> > ans(3 * n, vector <int> (3 * m));

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (field[i][j] == '.')
            {
                int ptr = i - 1;

                while (ptr >= 0 && !key_dir[ptr][j][2] && field[ptr][j] != '#')
                    ptr--;

                if (ptr < 0 || field[ptr][j] == '#')
                    ans[i * 3][j * 3 + 1] = -(i - ptr - 1);
                else
                    ans[i * 3][j * 3 + 1] = i - ptr;

                ptr = i + 1;

                while (ptr < n && !key_dir[ptr][j][0] && field[ptr][j] != '#')
                    ptr++;

                if (ptr >= n || field[ptr][j] == '#')
                    ans[i * 3 + 2][j * 3 + 1] = -(ptr - i - 1);
                else
                    ans[i * 3 + 2][j * 3 + 1] = ptr - i;

                ptr = j - 1;

                while (ptr >= 0 && !key_dir[i][ptr][1] && field[i][ptr] != '#')
                    ptr--;

                if (ptr < 0 || field[i][ptr] == '#')
                    ans[i * 3 + 1][j * 3] = -(j - ptr - 1);
                else
                    ans[i * 3 + 1][j * 3] = j - ptr;

                ptr = j + 1;

                while (ptr < m && !key_dir[i][ptr][3] && field[i][ptr] != '#')
                    ptr++;

                if (ptr >= m || field[i][ptr] == '#')
                    ans[i * 3 + 1][j * 3 + 2] = -(ptr - j - 1);
                else
                    ans[i * 3 + 1][j * 3 + 2] = ptr - j;
            }


    for (int i = 0; i < n * 3; i++)
    {
        for (int j = 0; j < m * 3; j++)
            if (i % 3 == 0 && j % 3 == 0 || i % 3 == 0 && j % 3 == 2 || i % 3 == 2 && j % 3 == 0 || i % 3 == 2 && j % 3 == 2 || i % 3 == 1 && j % 3 == 1)
                cout << "* ";
            else if (field[i / 3][j / 3] == '#')
                cout << "W ";
            else
                cout << ans[i][j] << " ";

        cout << "\n";
    }
}
